//+------------------------------------------------------------------+
//|                                                     Sample_4.mq4 |
//|                                      Copyright  2007, komposter |
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, komposter"
#property link      "mailto:komposterius@mail.ru"
//----
extern int 			MagicNumber	= 3345;	//   .
extern double		Lot								= 1.0;
//      (0 -  )
extern int			StopLoss					= 50;
//      (0 -  )
extern int			TakeProfit			= 250;	
/*
period -   .    0
method -   .    0  3:
			MODE_SMA  0    
			MODE_EMA  1    
			MODE_SMMA 2    
			MODE_LWMA 3 -   
price  -  .    0  6:
			PRICE_CLOSE		0   
			PRICE_OPEN		1   
			PRICE_HIGH		2   
			PRICE_LOW		3   
			PRICE_MEDIAN	4  , (high+low)/2 
			PRICE_TYPICAL	5  , (high+low+close)/3 
			PRICE_WEIGHTED	6   , (high+low+close+close)/4 
*/
extern int	fastMA_period	= 9;
extern int	fastMA_method	= 0;
extern int	fastMA_price		= 0;

extern int	slowMA_period	= 18;
extern int	slowMA_method	= 0;
extern int	slowMA_price		= 0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
	  double fastMA_1 = iMA(NULL, 0, fastMA_period, 0, fastMA_method, 
	                        fastMA_price, 1);
	  double slowMA_1 = iMA(NULL, 0, slowMA_period, 0, slowMA_method, 
	                        slowMA_price, 1);
	  double fastMA_2 = iMA(NULL, 0, fastMA_period, 0, fastMA_method, 
	                        fastMA_price, 2);
	  double slowMA_2 = iMA(NULL, 0, slowMA_period, 0, slowMA_method, 
	                        slowMA_price, 2);
	  int _OrdersTotal = OrdersTotal(); 
	  bool ExpertOrder = false;
	  for(int z = _OrdersTotal - 1; z >= 0; z --)
	    {
		     if(!OrderSelect(z, SELECT_BY_POS, MODE_TRADES)) 
		         continue;
		     if(OrderMagicNumber() != MagicNumber || OrderSymbol() != Symbol()) 
		         continue;
		     ExpertOrder = true;
		     if(OrderType() == OP_BUY)
		       {
			        if(NormalizeDouble(slowMA_1 - fastMA_1, Digits ) > 0.0)
			          {
				           if(NormalizeDouble(fastMA_2 - slowMA_2, Digits ) >= 0.0)
				             {
					              if(!OrderClose(OrderTicket(), OrderLots(), Bid, 0, Blue))
						                 Alert("   BUY-!!!");
				             }
			          }
			        continue;
		       }
       if(OrderType() == OP_SELL)
         {
           if(NormalizeDouble(fastMA_1 - slowMA_1, Digits) > 0.0)
             {
	              if(NormalizeDouble(slowMA_2 - fastMA_2, Digits ) >= 0.0)
	                {
		                 if(!OrderClose(OrderTicket(), OrderLots(), Ask, 0, Red))
			                    Alert("   SELL-!!!");
	                }
             }
           continue;
         }
     }
	  if(ExpertOrder) 
	      return;
	  double sl, tp;
	  if(NormalizeDouble(fastMA_1 - slowMA_1, Digits) > 0.0)
	    {
		     if(NormalizeDouble(slowMA_2 - fastMA_2, Digits) >= 0.0)
		       {
			        if(StopLoss > 0)
				           sl = NormalizeDouble(Bid - StopLoss*Point, Digits);
			        else
				           sl = 0.0;
			        if(TakeProfit > 0)
				           tp = NormalizeDouble(Bid + TakeProfit*Point, Digits);
			        else
				           tp = 0.0;
			        if(OrderSend(Symbol(), OP_BUY, Lot, Ask, 0, sl, tp, 
			           "MA Expert", MagicNumber ) < 0)
				           Alert("   BUY-!!!");
		       }
	    }
	  if(NormalizeDouble(slowMA_1 - fastMA_1, Digits) > 0.0)
	    {
		     if(NormalizeDouble(fastMA_2 - slowMA_2, Digits) >= 0.0)
		       {
			        if(StopLoss > 0 )
				           sl = NormalizeDouble(Ask + StopLoss*Point, Digits);
			        else
				           sl = 0.0;
			        if(TakeProfit > 0)
				           tp = NormalizeDouble(Ask - TakeProfit*Point, Digits);
			        else
				           tp = 0.0;
			        if(OrderSend(Symbol(), OP_SELL, Lot, Bid, 0, sl, tp, 
			           "MA Expert", MagicNumber) < 0)
				           Alert("   SELL-!!!");
		       }
	    }
	  return(0);
  }
//+------------------------------------------------------------------+


